let table;
let carCode = [
  'Audi',
  'BMW',
  'Mercedes',
  'Porsche',
  'Volkswagen',
];
let dataMap;
let randomList;
let totalR = 0;
let colorList = [
  '#5F9EA0',
  '#FF8C00',
  '#6495ED',
  '#CD5C5C',
  '#66CDAA',
  '#FF4500',
  '#CD853F',
];

function preload() {
  table = loadTable(
    'https://gist.githubusercontent.com/vishusikka/eaed689e84019a23b19a23cb0f845d47/raw/d75dd022d31e5b63582be402747d00227a949520/stripchart.csv',
    'csv',
    'header'
  ).getRows();
}

function setup() {
  dataMap = new Map();
  for (var i = 0; i < table.length; i++) {
    if (carCode.includes(table[i].get('Make'))) {
      let minute = table[i].getNum('Avg.City.mpg');
      let code = table[i].get('Make');
      dataMap[code] = dataMap[code] || [];
      dataMap[code].push(minute);
      totalR++;
    }
  }
  randomList = [];
  for (let i = 0; i < totalR; i++) {
    randomList[i] = random(-18, 18);
  }
  createCanvas(1500, 1000);
}

function draw() {
  background('light');
  fill('#8c8c8c');
  textSize(16);
  textStyle(BOLD);
  let barWidth = 100;
  for (let i = 0; i < carCode.length; i++) {
    text(carCode[i], i * barWidth + 340, 675);
  }
  textAlign(RIGHT);
  for (let i = 0, j = 0; i <= 40; i += 5, j++) {
    height = 650 - j * 50;
    text(i, 295, height);
    stroke(200);
    strokeWeight(1);
    line(300, height, 850, height);
    noStroke();
  }

  fill('black');
  push();
  let angle2 = radians(-90);
  translate(-220, 680);
  rotate(angle2);
  textSize(18);
  textAlign(CENTER);
  text('Avg.City.mpg', 230, 480);
  pop();
  stroke(126);
  strokeWeight(1);
  line(300, 650, 850, 650); //x axis
  line(300, 250, 300, 650); //y axis
  noStroke();
  textSize(12);
  textAlign(RIGHT);
  textSize(24);
  textAlign(LEFT);
  text('STRIP CHART WITH JITTER & TOOLTIPS', 340, 150);
  textSize(12);
  text(
    'for avg city mpg across all makes and models 2009-2012',
    400,
    170
  );
  fill('black');

  for (let i = 0; i < carCode.length; i++) {
    let detail = dataMap[carCode[i]];
    let recordNum = detail.length;
    for (let j = 0; j < detail.length; j++) {
      let mid = i * barWidth + 360;
      let x1 = mid + randomList[i * recordNum + j];
      let y1 = 650 - (detail[j] / 30) * 310;
      stroke(colorList[i]);
      strokeWeight(10);
      //console.log("code ", carCode[i], " y1 ", y1)
      point(x1, y1);
      noStroke();
      mouseHover(x1, x1, y1, y1, detail[j]);
    }
  }
}

function mouseHover(x_l, x_r, y_h1, y_h2, message) {
  if (
    mouseX > x_l - 3 &&
    mouseX < x_r + 3 &&
    mouseY > y_h2 - 3 &&
    mouseY < y_h1 + 3
  ) {
    noStroke();
    fill(0);
    textSize(14);
    text(message, x_l + 10, y_h2 - 10);
  }
}
